/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.Keys;
import de.ship.db.tables.TCoreElementHierarchy.TCoreElementHierarchyPath;
import de.ship.db.tables.TDmTablecopy.TDmTablecopyPath;
import de.ship.db.tables.TDmTablegrpdetail.TDmTablegrpdetailPath;
import de.ship.db.tables.TDmTranspose.TDmTransposePath;
import de.ship.db.tables.records.TDmTabledefRecord;

import java.time.LocalDateTime;
import java.util.Arrays;
import java.util.Collection;
import java.util.List;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Identity;
import org.jooq.InverseForeignKey;
import org.jooq.Name;
import org.jooq.Path;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.Record;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class TDmTabledef extends TableImpl<TDmTabledefRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.t_dm_tabledef</code>
     */
    public static final TDmTabledef T_DM_TABLEDEF = new TDmTabledef();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<TDmTabledefRecord> getRecordType() {
        return TDmTabledefRecord.class;
    }

    /**
     * The column <code>common_dd.t_dm_tabledef.lastchange</code>.
     */
    public final TableField<TDmTabledefRecord, LocalDateTime> LASTCHANGE = createField(DSL.name("lastchange"), SQLDataType.LOCALDATETIME(6).defaultValue(DSL.field(DSL.raw("now()"), SQLDataType.LOCALDATETIME)), this, "");

    /**
     * The column <code>common_dd.t_dm_tabledef.pk</code>.
     */
    public final TableField<TDmTabledefRecord, Integer> PK = createField(DSL.name("pk"), SQLDataType.INTEGER.nullable(false).identity(true), this, "");

    /**
     * The column <code>common_dd.t_dm_tabledef.fk_element</code>. reference to
     * key_element
     */
    public final TableField<TDmTabledefRecord, Integer> FK_ELEMENT = createField(DSL.name("fk_element"), SQLDataType.INTEGER.nullable(false), this, "reference to key_element");

    /**
     * The column <code>common_dd.t_dm_tabledef.schemaname</code>. name of
     * oracle schema that contains data table
     */
    public final TableField<TDmTabledefRecord, String> SCHEMANAME = createField(DSL.name("schemaname"), SQLDataType.CLOB.nullable(false), this, "name of oracle schema that contains data table");

    private TDmTabledef(Name alias, Table<TDmTabledefRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private TDmTabledef(Name alias, Table<TDmTabledefRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.table(), where);
    }

    /**
     * Create an aliased <code>common_dd.t_dm_tabledef</code> table reference
     */
    public TDmTabledef(String alias) {
        this(DSL.name(alias), T_DM_TABLEDEF);
    }

    /**
     * Create an aliased <code>common_dd.t_dm_tabledef</code> table reference
     */
    public TDmTabledef(Name alias) {
        this(alias, T_DM_TABLEDEF);
    }

    /**
     * Create a <code>common_dd.t_dm_tabledef</code> table reference
     */
    public TDmTabledef() {
        this(DSL.name("t_dm_tabledef"), null);
    }

    public <O extends Record> TDmTabledef(Table<O> path, ForeignKey<O, TDmTabledefRecord> childPath, InverseForeignKey<O, TDmTabledefRecord> parentPath) {
        super(path, childPath, parentPath, T_DM_TABLEDEF);
    }

    /**
     * A subtype implementing {@link Path} for simplified path-based joins.
     */
    public static class TDmTabledefPath extends TDmTabledef implements Path<TDmTabledefRecord> {

        private static final long serialVersionUID = 1L;
        public <O extends Record> TDmTabledefPath(Table<O> path, ForeignKey<O, TDmTabledefRecord> childPath, InverseForeignKey<O, TDmTabledefRecord> parentPath) {
            super(path, childPath, parentPath);
        }
        private TDmTabledefPath(Name alias, Table<TDmTabledefRecord> aliased) {
            super(alias, aliased);
        }

        @Override
        public TDmTabledefPath as(String alias) {
            return new TDmTabledefPath(DSL.name(alias), this);
        }

        @Override
        public TDmTabledefPath as(Name alias) {
            return new TDmTabledefPath(alias, this);
        }

        @Override
        public TDmTabledefPath as(Table<?> alias) {
            return new TDmTabledefPath(alias.getQualifiedName(), this);
        }
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public Identity<TDmTabledefRecord, Integer> getIdentity() {
        return (Identity<TDmTabledefRecord, Integer>) super.getIdentity();
    }

    @Override
    public UniqueKey<TDmTabledefRecord> getPrimaryKey() {
        return Keys.PK_DM_TABLEDEF;
    }

    @Override
    public List<UniqueKey<TDmTabledefRecord>> getUniqueKeys() {
        return Arrays.asList(Keys.UK_DM_TABLEDEF);
    }

    @Override
    public List<ForeignKey<TDmTabledefRecord, ?>> getReferences() {
        return Arrays.asList(Keys.T_DM_TABLEDEF__FK_TABLEDEF_ELEMENT);
    }

    private transient TCoreElementHierarchyPath _tCoreElementHierarchy;

    /**
     * Get the implicit join path to the
     * <code>common_dd.t_core_element_hierarchy</code> table.
     */
    public TCoreElementHierarchyPath tCoreElementHierarchy() {
        if (_tCoreElementHierarchy == null)
            _tCoreElementHierarchy = new TCoreElementHierarchyPath(this, Keys.T_DM_TABLEDEF__FK_TABLEDEF_ELEMENT, null);

        return _tCoreElementHierarchy;
    }

    private transient TDmTablecopyPath _tDmTablecopy;

    /**
     * Get the implicit to-many join path to the
     * <code>common_dd.t_dm_tablecopy</code> table
     */
    public TDmTablecopyPath tDmTablecopy() {
        if (_tDmTablecopy == null)
            _tDmTablecopy = new TDmTablecopyPath(this, null, Keys.T_DM_TABLECOPY__FK_TABLECOPY_TABLEDEF.getInverseKey());

        return _tDmTablecopy;
    }

    private transient TDmTablegrpdetailPath _tDmTablegrpdetail;

    /**
     * Get the implicit to-many join path to the
     * <code>common_dd.t_dm_tablegrpdetail</code> table
     */
    public TDmTablegrpdetailPath tDmTablegrpdetail() {
        if (_tDmTablegrpdetail == null)
            _tDmTablegrpdetail = new TDmTablegrpdetailPath(this, null, Keys.T_DM_TABLEGRPDETAIL__FK_TABLEGRPDETAIL_TABLEDEF.getInverseKey());

        return _tDmTablegrpdetail;
    }

    private transient TDmTransposePath _tDmTranspose;

    /**
     * Get the implicit to-many join path to the
     * <code>common_dd.t_dm_transpose</code> table
     */
    public TDmTransposePath tDmTranspose() {
        if (_tDmTranspose == null)
            _tDmTranspose = new TDmTransposePath(this, null, Keys.T_DM_TRANSPOSE__FK_TRANSPOSE_TABLEDEF.getInverseKey());

        return _tDmTranspose;
    }

    @Override
    public TDmTabledef as(String alias) {
        return new TDmTabledef(DSL.name(alias), this);
    }

    @Override
    public TDmTabledef as(Name alias) {
        return new TDmTabledef(alias, this);
    }

    @Override
    public TDmTabledef as(Table<?> alias) {
        return new TDmTabledef(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public TDmTabledef rename(String name) {
        return new TDmTabledef(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public TDmTabledef rename(Name name) {
        return new TDmTabledef(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public TDmTabledef rename(Table<?> name) {
        return new TDmTabledef(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TDmTabledef where(Condition condition) {
        return new TDmTabledef(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TDmTabledef where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TDmTabledef where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TDmTabledef where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TDmTabledef where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TDmTabledef where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TDmTabledef where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TDmTabledef where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TDmTabledef whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TDmTabledef whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
